=== debian/changelog ===
gcem (1.18.0-2) unstable; urgency=medium

  * Remove redundant Priority stanza from debian/control
  * Configure with -DCMAKE_POLICY_VERSION_MINIMUM=3.5 to fix FTBFS
    with CMake 4.2 (Closes: #1125530)

 -- Fabian Greffrath <fabian@debian.org>  Tue, 20 Jan 2026 08:07:55 +0100

gcem (1.18.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1117715)

 -- Fabian Greffrath <fabian@debian.org>  Fri, 10 Oct 2025 08:26:44 +0200
