=== debian/control ===
Source: gcem
Section: libs
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Fabian Greffrath <fabian@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Standards-Version: 4.7.2
Homepage: https://github.com/kthohr/gcem
Vcs-Browser: https://salsa.debian.org/multimedia-team/gcem
Vcs-Git: https://salsa.debian.org/multimedia-team/gcem.git

Package: libgcem-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
Description: C++ math library using generalized constant expressions
 GCE-Math (Generalized Constant Expression Math) is a templated C++ library
 enabling compile-time computation of mathematical functions.
 .
 Features:
 .
  * The library is written in C++11 constexpr format, and is C++11/14/17/20
    compatible.
  * Continued fraction expansions and series expansions are implemented using
    recursive templates.
  * The gcem:: syntax is identical to that of the C++ standard library (std::).
  * Tested and accurate to floating-point precision against the C++ standard
    library.
